/**
 *      Package : iWidget
 * 		version : 0.1
 * 		author  : Emad Elsaid (Blaze Boy)
 * 		e-mail  : blazeeboy@gmail.com
 * 		creation: 21.08.2010
 * 		description : 
 * 			i widget is a collection of jquery widgets 
 * 			made by me and some talented developers around the world
 * 			the plugins are self executable you only need to use 
 * 			the corresponding class to the container and iwidget 
 * 			will apply the plugin onload
 * 			this project aim to be a small beautiful alternative 
 * 			for Dojo Dijit library, with just 1 js and 1 css file 
 * 			you get all the sharm.
 *      
 *      Copyright 2010 blaze <blaze@blaze-laptop>
 *      
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */
/**
* All Plugins are based on Trevor Morris Skeleton Framework
*/

/**
* Skeleton: a jQuery Plugin
* @author: Trevor Morris (trovster)
* @url: http://www.trovster.com/lab/code/plugins/jquery.skeleton.js
* @documentation: http://www.trovster.com/lab/plugins/skeleton/
* @published: 11/09/2008
* @updated: 29/09/2008
*
* @notes: 
* Convention *I* use:
*  - $var is a jQuery object
*  - Quote key/value pairs
*  - Use o['key'] syntax when reading key/value
*/

/**
* iTitlePanel: 	jquery plugin to make title and content 
* 				title shows and hides the content
* @author: Emad Elsaid (Blaze Boy)
*/

if(typeof jQuery != 'undefined') {
	jQuery(function($) {
		$.fn.extend({
			ititlePanel: function(options) {
				var settings = $.extend({}, $.fn.ititlePanel.defaults, options);
			
				return this.each(
					function() {
						if($.fn.jquery < '1.2.6') {return;}
						var $t = $(this);
						
						var attr = {};
						if( $t.attr('speed') )
							attr.speed = parseInt($t.attr('speed'));
						
						if( $t.attr('closed') )
							attr.closed = $t.attr('closed');
						
						var settings = $.extend({}, settings, attr );
						
						$t.children(':first').click(function(){
							$(this).siblings().slideToggle(settings.speed,function(){
								$(this).parent().toggleClass('title-panel-collapsed');
							});
						});
						
						if( settings.closed=='y' )
						{
							$t.children().not(':first').hide();
							$t.addClass('title-panel-collapsed');
						}
					}
				);
			}
		});
		
		/**
		* Plugin Defaults Here…
		*/
		$.fn.ititlePanel.defaults = {speed:'normal',closed:'n'};
	});
}


/**
* iTabs: convert div with children into tabs and pages
*/
if(typeof jQuery != 'undefined') {
	jQuery(function($) {
		$.fn.extend({
			itabs: function(options) {
				var settings = $.extend({}, $.fn.itabs.defaults, options);
			
				return this.each(
					function() {
						if($.fn.jquery < '1.2.6') {return;}
						var $t = $(this);
						
						//get title , the even children
						$titles = $t.children(':even').addClass('title');
						// get pages , the odd children
						$content = $t.children(':odd').addClass('page');
						// remove titles and prepend them to the parent
						$titles.remove().prependTo($t);
						// hide all pages axcept the first one
						$content.not(':first').hide()
						
						$titles.eq(0).addClass('title-active');
						
						// handle the titles click action
						$titles.click(function(){
							$t = $(this)
							// get index of this title among his siblings
							index = $t.parent().children('.title').index($t);
							// hide the visible page
							$t.siblings('.page:visible').hide();
							// show the required page
							$t.siblings('.page').eq(index).show();
							
							$t.siblings('.title').removeClass('title-active');
							$t.addClass('title-active');
						});
					}
				);
			}
		});
		
		/**
		* Set your Plugin Defaults Here…
		*/
		$.fn.itabs.defaults = {};
	});
}

/**
* iaccordion: convert div with children into accordion
*/
if(typeof jQuery != 'undefined') {
	jQuery(function($) {
		$.fn.extend({
			iaccordion: function(options) {
				var settings = $.extend({}, $.fn.iaccordion.defaults, options);
			
				return this.each(
					function() {
						if($.fn.jquery < '1.2.6') {return;}
						var $t = $(this);
						
						//get title , the even children
						$titles = $t.children(':even').addClass('title');
						// get pages , the odd children
						$content = $t.children(':odd').addClass('page');
						// remove titles and prepend them to the parent
						// hide all pages axcept the first one
						$content.not(':first').hide()
						$t.children('.title:last').addClass('title-collapsed');
						
						$titles.eq(0).addClass('title-active');
						
						// handle the titles click action
						$titles.click(function(){
							$t = $(this)
							// get index of this title among his siblings
							index = $t.parent().children('.title').index($t);
							// hide the visible page
							$t.siblings('.page:visible').slideUp();
							// show the required page
							$t.siblings('.page').eq(index).slideDown();
							
							if( index!=$t.parent().children('.title').length-1 )
								$t.siblings('.title:last').addClass('title-collapsed');
							else
								$t.removeClass('title-collapsed');
								
							$t.siblings('.title').removeClass('title-active');
							$t.addClass('title-active');
						});
					}
				);
			}
		});
		
		/**
		* Set your Plugin Defaults Here…
		*/
		$.fn.iaccordion.defaults = {};
	});
}

/**
 * ih-menu : horizontal menu from UL
 */
if(typeof jQuery != 'undefined') {
	jQuery(function($) {
		$.fn.extend({
			ihmenu: function(options) {
				var settings = $.extend({}, $.fn.ihmenu.defaults, options);
			
				return this.each(
					function() {
						if($.fn.jquery < '1.2.6') {return;}
						var $t = $(this);
						
						$t.children('li').hover(function(){
							$(this).addClass('hover');
						},function(){
							$(this).removeClass('hover');
						});
					}
				);
			}
		});
		
		/**
		* Set your Plugin Defaults Here…
		*/
		$.fn.ihmenu.defaults = {};
	});
}

/**
 * iv-menu : vertical menu from UL
 */
if(typeof jQuery != 'undefined') {
	jQuery(function($) {
		$.fn.extend({
			ivmenu: function(options) {
				var settings = $.extend({}, $.fn.ivmenu.defaults, options);
			
				return this.each(
					function() {
						if($.fn.jquery < '1.2.6') {return;}
						var $t = $(this);
						
						$t.children('li').hover(function(){
							$(this).addClass('hover');
						},function(){
							$(this).removeClass('hover');
						});
					}
				);
			}
		});
		
		/**
		* Set your Plugin Defaults Here…
		*/
		$.fn.ivmenu.defaults = {};
	});
}

/**
 * tipsy - Facebook-style tooltip plugin for jQuery
 *	(c) 2008-2009 Jason Frame (jason@onehackoranother.com)
 *	Released under The MIT License.
 *  http://onehackoranother.com/projects/jquery/tipsy
 */
(function($) {
    $.fn.tipsy = function(options) {

        options = $.extend({}, $.fn.tipsy.defaults, options);
        
        return this.each(function() {
            
            var opts = $.fn.tipsy.elementOptions(this, options);
            
            $(this).hover(function() {

                $.data(this, 'cancel.tipsy', true);

                var tip = $.data(this, 'active.tipsy');
                if (!tip) {
                    tip = $('<div class="tipsy"><div class="tipsy-inner"/></div>');
                    tip.css({position: 'absolute', zIndex: 100000});
                    $.data(this, 'active.tipsy', tip);
                }

                if ($(this).attr('title') || typeof($(this).attr('original-title')) != 'string') {
                    $(this).attr('original-title', $(this).attr('title') || '').removeAttr('title');
                }

                var title;
                if (typeof opts.title == 'string') {
                    title = $(this).attr(opts.title == 'title' ? 'original-title' : opts.title);
                } else if (typeof opts.title == 'function') {
                    title = opts.title.call(this);
                }

                tip.find('.tipsy-inner')[opts.html ? 'html' : 'text'](title || opts.fallback);

                var pos = $.extend({}, $(this).offset(), {width: this.offsetWidth, height: this.offsetHeight});
                tip.get(0).className = 'tipsy'; // reset classname in case of dynamic gravity
                tip.remove().css({top: 0, left: 0, visibility: 'hidden', display: 'block'}).appendTo(document.body);
                var actualWidth = tip[0].offsetWidth, actualHeight = tip[0].offsetHeight;
                var gravity = (typeof opts.gravity == 'function') ? opts.gravity.call(this) : opts.gravity;

                switch (gravity.charAt(0)) {
                    case 'n':
                        tip.css({top: pos.top + pos.height, left: pos.left + pos.width / 2 - actualWidth / 2}).addClass('tipsy-north');
                        break;
                    case 's':
                        tip.css({top: pos.top - actualHeight, left: pos.left + pos.width / 2 - actualWidth / 2}).addClass('tipsy-south');
                        break;
                    case 'e':
                        tip.css({top: pos.top + pos.height / 2 - actualHeight / 2, left: pos.left - actualWidth}).addClass('tipsy-east');
                        break;
                    case 'w':
                        tip.css({top: pos.top + pos.height / 2 - actualHeight / 2, left: pos.left + pos.width}).addClass('tipsy-west');
                        break;
                }

                if (opts.fade) {
                    tip.css({opacity: 0, display: 'block', visibility: 'visible'}).animate({opacity: 0.8});
                } else {
                    tip.css({visibility: 'visible'});
                }

            }, function() {
                $.data(this, 'cancel.tipsy', false);
                var self = this;
                setTimeout(function() {
                    if ($.data(this, 'cancel.tipsy')) return;
                    var tip = $.data(self, 'active.tipsy');
                    if (opts.fade) {
                        tip.stop().fadeOut(function() { $(this).remove(); });
                    } else {
                        tip.remove();
                    }
                }, 100);

            });
            
        });
        
    };
    
    // Overwrite this method to provide options on a per-element basis.
    // For example, you could store the gravity in a 'tipsy-gravity' attribute:
    // return $.extend({}, options, {gravity: $(ele).attr('tipsy-gravity') || 'n' });
    // (remember - do not modify 'options' in place!)
    $.fn.tipsy.elementOptions = function(ele, options) {
        return $.extend({}, options, {gravity: $(ele).attr('tip') || 'n' });
    };
    
    $.fn.tipsy.defaults = {
        fade: true,
        fallback: '',
        gravity: 'n',
        html: false,
        title: 'title'
    };
    
    $.fn.tipsy.autoNS = function() {
        return $(this).offset().top > ($(document).scrollTop() + $(window).height() / 2) ? 's' : 'n';
    };
    
    $.fn.tipsy.autoWE = function() {
        return $(this).offset().left > ($(document).scrollLeft() + $(window).width() / 2) ? 'e' : 'w';
    };
    
})(jQuery);


/**
 * iewidth: equal width plugin  convert children to equal width children
 */
if(typeof jQuery != 'undefined') {
	jQuery(function($) {
		$.fn.extend({
			iewidth: function(options) {
				var settings = $.extend({}, $.fn.iewidth.defaults, options);
			
				return this.each(
					function() {
						if($.fn.jquery < '1.2.6') {return;}
						var $t = $(this);
						
						$children = $t.children();
						width = Math.floor(100/$children.length);
						$children.width(width+'%');
					}
				);
			}
		});
		
		/**
		* Set your Plugin Defaults Here…
		*/
		$.fn.iewidth.defaults = {};
	});
}

/**
 * iewidthE: equal width plugin  make selected equal width
 */
if(typeof jQuery != 'undefined') {
	jQuery(function($) {
		$.fn.extend({
			iewidthE: function(options) {
				var settings = $.extend({}, $.fn.iewidthE.defaults, options);
				
				return this.each(
					function() {
						if($.fn.jquery < '1.2.6') {return;}
						var $t = $(this);
						
						$children = $t.children(settings.ele);
						widest = 0;
						for( i=0; i<$children.length; i++ )
							if( widest < $($children.get(i)).outerWidth() )
								widest = $($children.get(i)).outerWidth();
						$children.width(widest);
					}
				);
			}
		});
		
		/**
		* Set your Plugin Defaults Here…
		*/
		$.fn.iewidthE.defaults = {'ele':'*'};
	});
}

/**
 * ieheight: equal height plugin  convert children to equal  height children
 */
if(typeof jQuery != 'undefined') {
	jQuery(function($) {
		$.fn.extend({
			ieheight: function(options) {
				var settings = $.extend({}, $.fn.ieheight.defaults, options);
			
				return this.each(
					function() {
						if($.fn.jquery < '1.2.6') {return;}
						var $t = $(this);
						
						$children = $t.children();
						tallest = 0;
						for( i=0; i<$children.length; i++ )
							if( tallest < $($children.get(i)).height() )
								tallest = $($children.get(i)).height();
						$children.height(tallest);
					}
				);
			}
		});
		
		/**
		* Set your Plugin Defaults Here…
		*/
		$.fn.ieheight.defaults = {};
	});
}

/**
 * islide: slides the content of an element
 */
if(typeof jQuery != 'undefined') {
	jQuery(function($) {
		$.fn.extend({
			islide: function(options) {
				var settings = $.extend({}, $.fn.islide.defaults, options);
			
				return this.each(
					function() {
						if($.fn.jquery < '1.2.6') {return;}
						var $t = $(this);
						
						var attr = {};
						if( $t.attr('limit') )
							attr.limit = parseInt($t.attr('limit'));
						
						if( $t.attr('speed') )
							attr.speed = parseInt($t.attr('speed'));
						
						localsettings = $.extend({}, settings, attr );
						$t.attr('speed',localsettings.speed);
						
				        var $ele = new Array();
						//get all the elements from container
						var $elements = $t.children().each(function(){
													$ele.push(
															  $(this)
															  	.clone()
																.css('opacity',0)
															  )
													$(this).remove();
									});
						//reverse them to be in the right order
						$ele.reverse();
						//add the initial elements to container
						for(i=0;i<localsettings.limit && $ele.length>0 ;i++)
						{
							$ele.pop().appendTo($t).css('opacity',1);
						}
						
						
						function step()
						{
							$t.children(':first').animate({opacity:0},parseInt($t.attr('speed')),function(){
																$ele.reverse();
																$ele.push( $(this).clone() );
																$(this).remove();
																$ele.reverse()
																	.pop()
																	.appendTo($t)
																	.animate({opacity:1},parseInt($t.attr('speed')),step);
														});
						}
						step();
					}
				);
			}
		});
		
		/**
		* Set your Plugin Defaults Here…
		*/
		$.fn.islide.defaults = {limit:3,speed:1000};
	});
}

/**
 * Itree : Tree from UL
 */
if(typeof jQuery != 'undefined') {
	jQuery(function($) {
		$.fn.extend({
			itree: function(options) {
				var settings = $.extend({}, $.fn.itree.defaults, options);
			
				return this.each(
					function() {
						if($.fn.jquery < '1.2.6') {return;}
						var $t = $(this);
						
						$uls = $t.find('ul');
						$uls.hide();
						
						$folders = $t.find('ul').parent();
						$folders.addClass('folder');
						
						$files = $t.find('li').not('.folder');
						$files.addClass('file');
						
						$lis = $t.find('li').children('a');
						$lis.click(function(){
							$subtree = $(this).parent().children('ul');
							if($subtree.length>0)
							{
								$(this).parent().toggleClass('folder-open');
								$subtree.slideToggle();
								return false;
							}
							return true;
						});
						
					}
				);
			}
		});
		
		/**
		* Set your Plugin Defaults Here…
		*/
		$.fn.itree.defaults = {};
	});
}


/**
 * Iform : additional capabilities for form
 */

if(typeof jQuery != 'undefined') {
	jQuery(function($) {
		$.fn.extend({
			iform: function(options) {
				var settings = $.extend({}, $.fn.iform.defaults, options);
			
				return this.each(
					function() {
						if($.fn.jquery < '1.2.6') {return;}
						var $t = $(this);
						
						/**
						* Start your Plugin Here…
						*/
						$t.iewidthE({ele:'label'});
						$t.iewidthE({ele:'input[type="text"],input[type="password"],textarea,select'});
						$t.iewidthE({ele:'button'});
						
						$t.find("input[value=''],textarea[value='']")
						
								.each(function(){
									$(this).addClass('empty')
									$(this).val($(this).attr('empty'));
								});
						
						$t.find("input,textarea")
								.focus(function(){
									$t = $(this);
									if( $t.val()==$t.attr('empty') )
									{
										$t.val('');
									}
									$t.removeClass('empty');
								})
								.blur(function(){
									$t = $(this);
									if( $t.val()=='' )
									{
										$t.val($t.attr('empty'));
										$t.addClass('empty');
									}
								})
						
					}
				);
			}
		});
		
		/**
		* Set your Plugin Defaults Here…
		*/
		$.fn.iform.defaults = {};
	});
}



/**
 * ===============================
 * Document Parser Here
 * ===============================
 */

$(function(){
	$('.title-panel').ititlePanel();
	$('.tabs').itabs();
	$('.accordion').iaccordion();
	$('.h-menu').ihmenu();
	$('.v-menu').ivmenu();
	$('*[title]').tipsy();
	$('.equal-width').iewidth();
	$('.equal-height').ieheight();
	$('.slide').islide();
	$('.tree').itree();
	$('.form').iform();
});
